Subject: Re: unregister_netdevice: waiting for lo to become free. Usage count = 8

From: [email-masked] (Eric W. Biederman)
Date: Fri, 15 Apr 2011 00:27:20 -0700

Hans Schillstrom <[email-masked]> writes:

> Hello Julian
>
> I'm trying to fix the cleanup process when a namespace get "killed",
> which is a new feature for ipvs. However an old problem appears again
>
> When there has been traffic trough ipvs where the destination is unreachable
> the usage count on loopback dev increases one for every packet....
> I guess thats because of this rule :
>
> # ip route list table all
> ...
> unreachable default dev lo  table 0  proto kernel  metric 4294967295  error -101 hoplimit 25
> ...
>
> I made a test just forwarding packets through the same container (ipvs loaded)
> to an unreachable destination and that test had a balanced count i.e. it was possible to reboot the container.
>
> Do you have an idea why  this happens in the ipvs case ?

Hans.  I do know that most outstanding references when you clean up a
container get moved to the loopback device.  So it may not originally
be the loopback device itself where the reference counting is wrong.

Eric